#include <windows.h>
#include <xpppar.h>
#include <xppcon.h>
//-------------------------------------------------------------------------------------------------------------------------
#include <bap2.h>
#define MYHEAPFLAGS    (HEAP_GENERATE_EXCEPTIONS | HEAP_ZERO_MEMORY)
//-------------------------------------------------------------------------------------------------------------------------
#define BA_CB_LPOFNHOOKPROC  100
#define BA_CB_ADDZIP         200
#define BA_CB_GENERIC1       401
#define BA_CB_GENERIC2       402
#define BA_CB_GENERIC3       403
#define BA_CB_GENERIC4       404
//-------------------------------------------------------------------------------------------------------------------------
static LPSTR Get_CallBackName(void);
static void  Set_CallBackName(LPSTR);
static UINT CALLBACK bap_OFNHookProc(HWND hDlg,UINT uiMsg,WPARAM wParam,LPARAM lParam);
static int  CALLBACK bap_AddZip(UINT,UINT,LPSTR);
static int  CALLBACK bap_Gen0( void );
static int  CALLBACK bap_Gen1(LONG);
static int  CALLBACK bap_Gen2(LONG,LONG);
static int  CALLBACK bap_Gen3(LONG,LONG,LONG);
static int  CALLBACK bap_Gen4(LONG,LONG,LONG,LONG);
//-------------------------------------------------------------------------------------------------------------------------
static DWORD _dwTlsBap_ = 0;
//-------------------------------------------------------------------------------------------------------------------------
static void * _xgrab( UINT n);
static void _xfree( void * p);
static void * _xgrow( void * p , UINT n);
static LPBYTE _bcopy(LPBYTE pDest, LPBYTE pSrc , UINT nBytes);
static ULONG XPPAPIENTRY BapInitProc(void * p);
static ULONG XPPAPIENTRY BapExitProc(void * p);
//-------------------------------------------------------------------------------------------------------------------------
static HANDLE hHeap_x = (HANDLE) 0;
ULONG _xppDouble_ = 0;
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BAINIT( XppParamList pl);
XPPRET XPPENTRY BASTRUCT( XppParamList pl);
XPPRET XPPENTRY BAACCESS( XppParamList pl);
XPPRET XPPENTRY BAEXTRACT( XppParamList pl);
XPPRET XPPENTRY BACALLBACK( XppParamList pl);
XPPRET XPPENTRY STRINGOF( XppParamList pl);
XPPRET XPPENTRY WORDOF( XppParamList pl);
XPPRET XPPENTRY BYTEOF( XppParamList pl);
XPPRET XPPENTRY LOGICOF( XppParamList pl);
XPPRET XPPENTRY BAEXVALUE( XppParamList pl);
XPPRET XPPENTRY BAEXPOINTER( XppParamList pl);
XPPRET XPPENTRY BADEREFERENCE( XppParamList pl);
XPPRET XPPENTRY BAEVALPTRARRAY( XppParamList pl);
XPPRET XPPENTRY BACLEAR( XppParamList pl);
//-------------------------------------------------------------------------------------------------------------------------
static XppRegisterTable _functions_table_;
static XppRegisterFunction _functions_[] = {{"BAINIT",BAINIT},
                                            {"BASTRUCT",BASTRUCT},
                                            {"BAEXTRACT",BAEXTRACT},
                                            {"BAACCESS",BAACCESS},
                                            {"BACALLBACK",BACALLBACK},
                                            {"STRINGOF",STRINGOF},
                                            {"WORDOF",WORDOF},
                                            {"BYTEOF",BYTEOF},
                                            {"LOGICOF",LOGICOF},
                                            {"BAEXVALUE",BAEXVALUE},
                                            {"BAEXPOINTER",BAEXPOINTER},
                                            {"BADEREFERENCE",BADEREFERENCE},
                                            {"BAEVALPTRARRAY",BAEVALPTRARRAY},
                                            {"BACLEAR",BACLEAR}};
//-------------------------------------------------------------------------------------------------------------------------
static XppDllRegistration __dllreg__ = { _functions_,sizeof(_functions_) / sizeof(XppRegisterFunction),
                                         0,BapInitProc,BapExitProc,NULL
                                       };
//-------------------------------------------------------------------------------------------------------------------------
BOOL WINAPI DllMain( HINSTANCE hDll, DWORD dwReason, LPVOID lpReserved )
{
   lpReserved;hDll; // UNUSED PARAMS
   switch( dwReason )
   {
       case DLL_PROCESS_ATTACH:
       {
          if (!_conRegisterDll((ULONG) hDll, &__dllreg__)) return 0;
          hHeap_x = HeapCreate(HEAP_GENERATE_EXCEPTIONS, 0x0400 , 0); // Common Heap
          _dwTlsBap_ = TlsAlloc();
          break;
       }
       case DLL_THREAD_ATTACH:{break;}
       case DLL_THREAD_DETACH:{break;}
       case DLL_PROCESS_DETACH:
       {
          _conUnRegisterDll( (ULONG) hDll);
          if(hHeap_x  != 0) HeapDestroy( hHeap_x ); hHeap_x = (HANDLE) 0;
          if(_dwTlsBap_) TlsFree(_dwTlsBap_);
          break;
       }
    }
    return TRUE;
}
//-------------------------------------------------------------------------------------------------------------------------
static ULONG XPPAPIENTRY BapInitProc(void * p)
{
   ContainerHandle con = _conPutND(NULLCONTAINER,0.00F);
   _conType(con,&_xppDouble_); _conRelease(con); con = NULLCONTAINER;
   _xppDouble_ &= 0xFFFFFF00;
    p; // UNUSED PARAM;
    return 1;
}
//-------------------------------------------------------------------------------------------------------------------------
static ULONG XPPAPIENTRY BapExitProc(void * p){p;return 1;}
//-------------------------------------------------------------------------------------------------------------------------
static void * _xgrab( UINT n)
{
   UINT * pSize = (UINT*) HeapAlloc( hHeap_x , MYHEAPFLAGS , n + sizeof(UINT) );
   LPSTR  p = (LPSTR) (((LPSTR)((void*)pSize)) + sizeof( UINT) );
   pSize[0] = n;
   return (void*) p;
}
//-------------------------------------------------------------------------------------------------------------------------
static void _xfree( void * p )
{
   DWORD  dw = (DWORD) (((DWORD) p ) - sizeof(UINT));
   HeapFree(hHeap_x,0,(void*) dw);
}
//-------------------------------------------------------------------------------------------------------------------------
static void * _xgrow( void * p , UINT n)
{
   UINT * pOldSize = (UINT*) ((void*)(((DWORD) p ) - sizeof(UINT)));
   if( pOldSize[0] < n )
   {
      void * pNew = _xgrab(n);
      _bcopy((LPBYTE)pNew,(LPBYTE)p,pOldSize[0]);
      return  pNew;
   }
   return p;
}
//-------------------------------------------------------------------------------------------------------------------------

static LPBYTE _bcopy(LPBYTE pDest, LPBYTE pSrc , UINT nBytes)
{
   if( nBytes )
   {
      UINT n;
      for( n = 0; n < nBytes ; n++) pDest[n] = pSrc[n];
   }
   return pDest;
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BAINIT( XppParamList pl)  // BaInit(nSize) -> aBin
{
   LONG   nItems = _parnl(pl,1);
   LPSTR  pInfo  = NULL;
   if( nItems > 0)
   {
      DWORD cbInfo  = sizeof(BAP2_HEADER) + ( nItems * sizeof(BAP2_ITEM) ) + 1 ;
      BAP2_HEADER * pHead;
      pInfo   = (LPSTR) _xgrab(cbInfo);
      pHead   = (BAP2_HEADER *) pInfo;
      pHead->dwItems       = (DWORD) nItems;
   }
   _retnl(pl,(LONG) pInfo);
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BASTRUCT( XppParamList pl) // BaStruct(aBin, [@]xValue) -> lOk
{
   BOOL bOk = FALSE;
   LPSTR  pInfo  = (LPSTR) _parnl(pl,1,0);
   if( pInfo )
   {
      BAP2_HEADER * pHead = (BAP2_HEADER *) pInfo;
      BAP2_ITEM * pItems = (BAP2_ITEM *) (pInfo + sizeof(BAP2_HEADER));
      if( pHead->dwPos < pHead->dwItems )
      {
         BAP2_ITEM * pItem = &(pItems[pHead->dwPos]);
         BOOL bValueByRef = FALSE;
         ContainerHandle conValue = _conParam(pl,2,&bValueByRef);
         if( conValue != NULLCONTAINER )
         {
            ULONG ulValType = 0;
            _conType(conValue , &ulValType);
            if( ulValType & (XPP_CHARACTER | XPP_NUMERIC | XPP_LOGICAL) )
            {
               LPSTR pBuffer  = NULL;
               LPSTR pStrVal  = NULL;
               ULONG cb = 0;
               BOOL bStrLock = FALSE;
               DWORD dwNewCap = 0;

               pItem->dwOffSet = pHead->dwSize;
               if( ulValType & XPP_CHARACTER )  bStrLock = (_conRLockC(conValue,&pStrVal,&cb)== 0);
               if( (!bValueByRef) && (ulValType & XPP_CHARACTER) ) dwNewCap = (DWORD) (((pHead->dwSize + cb)|511)+1);
               else  dwNewCap = (DWORD) (((pHead->dwSize + sizeof(DWORD) )|511)+1);
               if( pHead->dwCapacity < dwNewCap )
               {
                  pHead->dwCapacity = dwNewCap;
                  if( pHead->hBuffer ) pHead->hBuffer = _xgrow(pHead->hBuffer, dwNewCap );
                  else pHead->hBuffer = _xgrab(dwNewCap);
               }
               pBuffer = (LPSTR) ( pHead->hBuffer );
               if( pBuffer )
               {
                  pBuffer += pItem->dwOffSet;
                  if( ulValType & XPP_CHARACTER)
                  {
                     pItem->ulType    = XPP_CHARACTER;
                     pItem->dwSize    = cb;
                     if( bValueByRef )
                     {
                        DWORD dwPt = 0;

                        pItem->pRef = (LPSTR) _xgrab(cb+1);
                        if(bStrLock) _bcopy( (LPBYTE) pItem->pRef , (LPBYTE) pStrVal , cb );
                        dwPt = (DWORD) pItem->pRef;
                        _bcopy( (LPBYTE) pBuffer , (LPBYTE) &dwPt , sizeof(DWORD) );
                        pHead->dwSize += sizeof(DWORD);
                     }
                     else
                     {
                        if(bStrLock) _bcopy( (LPBYTE) pBuffer , (LPBYTE) pStrVal , cb );
                        pHead->dwSize += cb;
                     }
                  }
                  else
                  {
                     LONG nValue = 0;
                     pItem->ulType    = ( ulValType & 0x0F );
                     pItem->dwSize  =  sizeof(LONG);
                     pHead->dwSize += pItem->dwSize;
                     if(ulValType & XPP_LOGICAL ) _conGetL( conValue ,(BOOL*) &nValue );
                     else if(ulValType & _xppDouble_ )
                     {
                        double ndValue = 0.00F;
                        _conGetND( conValue , &ndValue);
                        nValue = (LONG) ndValue;  
                     }
                     else _conGetNL( conValue , &nValue );
                     if( bValueByRef )
                     {
                        DWORD dwPt = 0;
                        pItem->pRef = (LPSTR) _xgrab(sizeof(LONG));
                        _bcopy( (LPBYTE) pItem->pRef , (LPBYTE) &nValue , sizeof(LONG) );
                        dwPt = (DWORD) pItem->pRef;
                        _bcopy( (LPBYTE) pBuffer , (LPBYTE) &dwPt , sizeof(DWORD) );
                     }
                     else _bcopy( (LPBYTE) pBuffer , (LPBYTE) &nValue , sizeof(LONG) );
                  }
                  if(bStrLock) _conUnlockC(conValue);
                  pStrVal = NULL;
                  pBuffer = NULL;
                  pHead->dwPos++;
                  bOk = TRUE;
               }
            }
            if( !bValueByRef ) _conRelease( conValue );
         }
      }
   }
   _retl(pl,bOk);
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BAACCESS( XppParamList pl) // BaAccess(aBin) -> cBin
{
   BAP2_HEADER * pHead = (BAP2_HEADER *) _parnl(pl,1,0);
   if(pHead )
   if(pHead->hBuffer )
   {
      LPSTR pBuffer = (LPSTR) ( pHead->hBuffer );
      pHead->dwPos = 0;
      if( pBuffer )
      {
         _retclen(pl,pBuffer,pHead->dwSize);
         //( pHead->hBuffer );
         return;
      }
   }
   _ret(pl);
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BAEXTRACT( XppParamList pl) // BaExtract(aBin [, cBin] ) -> uValue
{
   BAP2_HEADER * pHead = (BAP2_HEADER *) _parnl(pl,1,0);
   BAP2_ITEM * pItems = (BAP2_ITEM *) ( ((LPSTR)pHead) + sizeof(BAP2_HEADER));
   ContainerHandle conr = NULLCONTAINER;
   __try{
      if(pHead )
      if(pHead->hBuffer )
      {
         LPSTR pBuffer = (LPSTR) ( pHead->hBuffer );
         if( pBuffer )
         {
            if( _partype(pl,2) & XPP_CHARACTER )
            {
               _parc(pBuffer,pHead->dwSize,pl,2,0);
               pHead->dwPos = 0;
            }
            if( pHead->dwPos < pHead->dwItems )
            {
               BAP2_ITEM * pItem = &(pItems[pHead->dwPos]);
               LPSTR pSrc = (pItem->pRef ? pItem->pRef : (pBuffer + pItem->dwOffSet) );
               DWORD cb   = pItem->dwSize;        
               switch( pItem->ulType & 0x0F )
               {
                  case XPP_CHARACTER: { conr = _conPutCL( conr , pSrc , cb ); break; }
                  case XPP_LOGICAL: { conr = _conPutL( conr , ((BOOL*)(pSrc))[0] ); break; }
                  case XPP_NUMERIC: { conr = _conPutNL( conr, ((LONG*)(pSrc))[0] ); break; }
               }
               if( pItem->pRef ) _xfree( (void*) pItem->pRef );
               pItem->pRef = NULL;
               pHead->dwPos++;
            }
            pBuffer = NULL;
         }
      }
      if( pHead->dwPos >= pHead->dwItems )
      {                             
         if(pHead->hBuffer) _xfree(pHead->hBuffer);
         _xfree( (void*) pHead );
         _stornl(0,pl,1,0);
      }
   }
   __finally {
      if( conr == NULLCONTAINER ) _ret(pl);
      else { _conReturn(pl,conr); _conRelease(conr); }
   }
}
//-------------------------------------------------------------------------------------------------------------------------
static LPSTR Get_CallBackName(void)
{
   if( _dwTlsBap_ ) return (LPSTR) TlsGetValue( _dwTlsBap_ );
   return NULL;
}
//-------------------------------------------------------------------------------------------------------------------------
static void Set_CallBackName(LPSTR p)
{
   if( _dwTlsBap_ )
   {
      void * pOld = TlsGetValue( _dwTlsBap_ );
      if(pOld) _xfree( pOld );
      TlsSetValue( _dwTlsBap_ , (void*) p);
   }
}
//-------------------------------------------------------------------------------------------------------------------------
static UINT CALLBACK bap_OFNHookProc(HWND p1,UINT p2,WPARAM p3,LPARAM p4)
{
   return (UINT) bap_Gen4((LONG)p1,(LONG)p2,(LONG)p3,(LONG)p4);
}
//-------------------------------------------------------------------------------------------------------------------------
static int  CALLBACK bap_AddZip(UINT p1,UINT p2,LPSTR p3)
{

  LPSTR pFN = Get_CallBackName();
  int nResult = 0;
  if( pFN )
  {
     ContainerHandle conr = _conPutNL(NULL,0);
     ContainerHandle pcon[3];
     pcon[0] = _conPutNL(NULL,(LONG) p1 & 0xFFFF);
     pcon[1] = _conPutNL(NULL,(LONG) p2 & 0xFFFF);
     pcon[2] = _conPutC(NULL, p3);
     if( _conCallPa( conr , pFN , 3 , pcon ) == 0 ) _conGetNL(conr,(LONG*)&nResult);
     _conRelease(conr);_conRelease(pcon[0]);_conRelease(pcon[1]); _conRelease(pcon[2]);
  }
  return nResult;
}
//-------------------------------------------------------------------------------------------------------------------------
static int  CALLBACK bap_Gen0( void )
{

  LPSTR pFN = Get_CallBackName();
  LONG nResult = 0;
  if( pFN )
  {
     ContainerHandle conr = _conPutNL(NULL,0);
     if( _conCall( conr , pFN , 0) == 0 ) _conGetNL(conr,&nResult);
     _conRelease(conr);
  }
  return nResult;
}
//-------------------------------------------------------------------------------------------------------------------------
static int  CALLBACK bap_Gen1(LONG p1 )
{
  LPSTR pFN = Get_CallBackName();
  LONG nResult = 0;
  if( pFN )
  {
     ContainerHandle conr = _conPutNL(NULL,0);
     ContainerHandle pcon[1];
     pcon[0] = _conPutNL(NULL,(LONG) p1);
     if( _conCallPa( conr , pFN , 1 , pcon ) == 0 ) _conGetNL(conr,&nResult);
     _conRelease(conr);_conRelease(pcon[0]);
  }
  return nResult;
}
//-------------------------------------------------------------------------------------------------------------------------
static int  CALLBACK bap_Gen2(LONG p1,LONG p2)
{
  LPSTR pFN = Get_CallBackName();
  LONG nResult = 0;
  if( pFN )
  {
     ContainerHandle conr = _conPutNL(NULL,0);
     ContainerHandle pcon[2];
     pcon[0] = _conPutNL(NULL,(LONG) p1);
     pcon[1] = _conPutNL(NULL,(LONG) p2);
     if( _conCallPa( conr , pFN , 2 , pcon ) == 0 ) _conGetNL(conr,&nResult);
     _conRelease(conr);_conRelease(pcon[0]);_conRelease(pcon[1]);
  }
  return nResult;
}
//-------------------------------------------------------------------------------------------------------------------------
static int  CALLBACK bap_Gen3(LONG p1,LONG p2 ,LONG p3)
{
  LPSTR pFN = Get_CallBackName();
  LONG nResult = 0;
  if( pFN )
  {
     ContainerHandle conr = _conPutNL(NULL,0);
     ContainerHandle pcon[3];
     pcon[0] = _conPutNL(NULL,(LONG) p1);
     pcon[1] = _conPutNL(NULL,(LONG) p2);
     pcon[2] = _conPutNL(NULL,(LONG) p3);
     if( _conCallPa( conr , pFN , 3 , pcon ) == 0 ) _conGetNL(conr,&nResult);
     _conRelease(conr);_conRelease(pcon[0]);_conRelease(pcon[1]); _conRelease(pcon[2]);
  }
  return nResult;
}
//-------------------------------------------------------------------------------------------------------------------------
static int  CALLBACK bap_Gen4(LONG p1,LONG p2 ,LONG p3 , LONG p4)
{

  LPSTR pFN = Get_CallBackName();
  LONG nResult = 0;
  if( pFN )
  {
     ContainerHandle conr = _conPutNL(NULL,0);
     ContainerHandle pcon[4];
     pcon[0] = _conPutNL(NULL,(LONG) p1);
     pcon[1] = _conPutNL(NULL,(LONG) p2);
     pcon[2] = _conPutNL(NULL,(LONG) p3);
     pcon[3] = _conPutNL(NULL,(LONG) p4);
     if( _conCallPa( conr , pFN , 4 , pcon ) == 0 )  _conGetNL(conr,&nResult);
     _conRelease(conr);_conRelease(pcon[0]);_conRelease(pcon[1]);
     _conRelease(pcon[2]);_conRelease(pcon[3]);
  }
  return nResult;
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BACALLBACK( XppParamList pl) // BaCallback( <cFuncName>, <nCallbackType>) pfn
{
   DWORD dwpfn  = 0;
   ULONG ul     = _parclen(pl,1,0);
   if(ul)
   {
      LPSTR pStr = _xgrab(ul+1);
      _parc(pStr,ul+1,pl,1,0);
      Set_CallBackName(pStr);
      switch( _parnl( pl , 2, 0) )
      {
         case BA_CB_LPOFNHOOKPROC :{ dwpfn = (DWORD) bap_OFNHookProc ; break;}
         case BA_CB_ADDZIP        :{ dwpfn = (DWORD) bap_AddZip      ; break;}
         case BA_CB_GENERIC1      :{ dwpfn = (DWORD) bap_Gen1        ; break;}
         case BA_CB_GENERIC2      :{ dwpfn = (DWORD) bap_Gen2        ; break;}
         case BA_CB_GENERIC3      :{ dwpfn = (DWORD) bap_Gen3        ; break;}
         case BA_CB_GENERIC4      :{ dwpfn = (DWORD) bap_Gen4        ; break;}
         default                  :{ dwpfn = (DWORD) bap_Gen0        ; break;}
      }
   }
   else Set_CallBackName(NULL);
   _retnl(pl,(LONG) dwpfn);
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY STRINGOF( XppParamList pl) // cVal := StringOf(nVal,[nLength])
{
   LPSTR p  = (LPSTR) _parnl(pl,1,0);
   ULONG cb = (ULONG) _parnl(pl,2,0);
   if( p )
   {
      if( cb == 0 ) _retc(pl,p);
      else _retclen(pl,p,cb);
   }
   else _ret(pl);
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY WORDOF( XppParamList pl){_retnl(pl,_parnl(pl,1,0)&0xFFFF);}
XPPRET XPPENTRY BYTEOF( XppParamList pl){_retnl(pl,_parnl(pl,1,0)&0xFF);}
XPPRET XPPENTRY LOGICOF( XppParamList pl){_retl(pl,(BOOL) _parnl(pl,1,0));}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BAEXVALUE( XppParamList pl) // cVal := BaExValue( cStruct, nPlace, nLength)
{
   BOOL bStrByRef = FALSE;
   ContainerHandle conc = NULLCONTAINER;
   BOOL bStrLock = FALSE;
   ContainerHandle conr = NULLCONTAINER;

 __try{
    ULONG nDstLen = (ULONG) _parnl(pl,3,0);
    if( nDstLen )
    {
       conc = _conParam(pl,1,&bStrByRef);
       if( conc != NULLCONTAINER)
       {
          LPSTR pSrc = NULL;
          ULONG nSrcLen = 0;
          bStrLock = (BOOL) ( _conRLockC(conc,&pSrc,&nSrcLen) == 0);
          if(bStrLock)
          {
             ULONG nShift = (ULONG) _parnl(pl,2,0);
             if( nShift > 0 ) nShift--;
             if( (nDstLen + nShift) <= nSrcLen ) _conPutCL(conr,(LPSTR) (pSrc + nShift) , nDstLen);
          }
       }
    }
    else conc = _conPutC(conc,"");
 } __finally {
    if( conc )
    {
       if( bStrLock ) _conUnlockC( conc ); bStrLock = FALSE;
       if( !bStrByRef ) _conRelease( conc ); conc = NULLCONTAINER;
    }
    if( conr == NULLCONTAINER ) _ret(pl);
    else { _conReturn(pl,conr); _conRelease(conr); }
 }
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BAEXPOINTER( XppParamList pl) // nAdr := BaExPointer( cStruct, nPlace)
{
   BOOL bStrByRef = FALSE;
   ContainerHandle conc = NULLCONTAINER;
   BOOL bStrLock = FALSE;
   LONG nResult = 0;

 __try{
    conc = _conParam(pl,1,&bStrByRef);
    if( conc != NULLCONTAINER)
    {
       LPSTR pSrc = NULL;
       ULONG nSrcLen = 0;
       bStrLock = (BOOL) ( _conRLockC(conc,&pSrc,&nSrcLen) == 0);
       if(bStrLock)
       {
          ULONG nShift = (ULONG) _parnl(pl,2,0);
          if( nShift > 0 ) nShift--;
          if( (sizeof(LONG) + nShift) <= nSrcLen ) _bcopy((LPBYTE) &nResult , (LPBYTE) (pSrc + nShift) , sizeof(LONG));
       }
    }
    else conc = _conPutC(conc,"");
 } __finally {
    if( conc )
    {
       if( bStrLock ) _conUnlockC( conc ); bStrLock = FALSE;
       if( !bStrByRef ) _conRelease( conc ); conc = NULLCONTAINER;
    }
    _retnl(pl,nResult);
 }
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BADEREFERENCE( XppParamList pl) // nAdr := BaDereference( nAddr)
{
   DWORD dwResult = 0;
 __try{
    DWORD* pdw = (DWORD*) ((void*)_parnl(pl,1,0));
    if(pdw) dwResult = pdw[0];
 } __finally {
    _retnl(pl,(LONG) dwResult);
 }
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BAEVALPTRARRAY( XppParamList pl) // nCnt := BaEvalPtrArray( cStruct, nPlace, cbEval)
{
   BOOL bStrByRef = FALSE;
   ContainerHandle conc = NULLCONTAINER;
   BOOL bStrLock = FALSE;
   LONG nCount = 0;

 __try{
    conc = _conParam(pl,1,&bStrByRef);
    if( conc != NULLCONTAINER)
    {    
       LPSTR pSrc = NULL;
       ULONG nSrcLen = 0;
       bStrLock = (BOOL) ( _conRLockC(conc,&pSrc,&nSrcLen) == 0);
       if(bStrLock)
       {  
          ULONG nShift = (ULONG) _parnl(pl,2,0);
          if( nShift > 0 ) nShift--;
          if( (sizeof(LONG) + nShift) <= nSrcLen )
          {
             BOOL bBlockByRef = FALSE;
             ContainerHandle conb = NULLCONTAINER;
             __try{
                conb = _conParam(pl,3,&bBlockByRef);
                if( conb != NULLCONTAINER )
                {
                   ULONG ulType = 0;
                   _conType(conb,&ulType);
                   if( ulType & XPP_BLOCK )
                   {
                      ULONG nItems = ((nSrcLen - nShift) >> 2);
                      LONG** pItems = (LONG**) ((void*)(pSrc + nShift));
                      ULONG n;
                      ContainerHandle conr = _conPutNL(NULLCONTAINER,0);
                      ContainerHandle conn = _conPutNL(NULLCONTAINER,0);
                      _try{
                         for( n = 0; ((n < nItems)?pItems[n]:FALSE); n++ )
                         {                   
                            _conEvalB(conr,conb,1,_conPutNL(conn,pItems[n][0]));
                            nCount++;
                         }
                      } __finally { 
                         _conRelease( conr ); _conRelease( conn );
                      }
                   }
                }
             } __finally {
                if( conb != NULLCONTAINER ) if( !bBlockByRef ) _conRelease( conb );
                conb = NULLCONTAINER;
             }
          }
       }
    }
    else conc = _conPutC(conc,"");
 } __finally {
    if( conc )
    {
       if( bStrLock ) _conUnlockC( conc ); bStrLock = FALSE;
       if( !bStrByRef ) _conRelease( conc ); conc = NULLCONTAINER;
    }
    _retnl(pl,nCount);
 }
}
//-------------------------------------------------------------------------------------------------------------------------
XPPRET XPPENTRY BACLEAR( XppParamList pl) // BaClear(hBin) -> NIL
{
   BAP2_HEADER * pHead = (BAP2_HEADER *) _parnl(pl,1,0);
   BAP2_ITEM * pItems = (BAP2_ITEM *) ( ((LPSTR)pHead) + sizeof(BAP2_HEADER));
   __try{
      if(pHead )
      {
         DWORD dw;
         for( dw = 0; dw < pHead->dwItems ; dw++)
         {
            BAP2_ITEM * pItem = &(pItems[dw]);
            __try{ if( pItem->pRef ) _xfree( (void*) pItem->pRef ); }
            __finally { pItem->pRef = NULL; }
         }                                   
         __try{  if(pHead->hBuffer) _xfree(pHead->hBuffer); } __finally{ ; }
         __try{  _xfree( (void*) pHead ); } __finally { ; }
      }
   }
   __finally {   _ret(pl);  }
}

